#RunIT Browser Copyright (c) 2015 JJ Posti <techtimejourney.net> 
#RunIT - THE WEBKIT BROWSER  comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991")

#!/usr/bin/env python

import sys
from gi.repository import Gtk, Gdk, WebKit, GObject, Soup

import os, shutil, json, datetime,subprocess
from subprocess import Popen, PIPE


class BrowserTab(Gtk.VBox):
    __gsignals__ = {
        "focus-view-title-changed": (GObject.SIGNAL_RUN_FIRST,
                                     GObject.TYPE_NONE,
                                     (GObject.TYPE_OBJECT, GObject.TYPE_STRING,)),
        "new-window-requested": (GObject.SIGNAL_RUN_FIRST,
                                 GObject.TYPE_NONE,
                                 (GObject.TYPE_OBJECT,)),
        "load-requested": (GObject.SIGNAL_RUN_FIRST,
                             GObject.TYPE_NONE,
                             (GObject.TYPE_STRING,)),
        "new-tab-requested": (GObject.SIGNAL_RUN_FIRST,
                             GObject.TYPE_NONE, ())                                 
        }
    def __init__(self, *args, **kwargs):
        super(BrowserTab, self).__init__(*args, **kwargs)

  
        
################        
#Addressbars
################
        self.address=Gtk.Entry()
        self.address.connect("activate", self.actual_going)
#####################
#Webview
#######################
        self.web = WebKit.WebView()
        self.web.connect("title-changed", self.navigation)
        self.web.open("http://www.techtimejourney.net/audax")
        self.show()
        
#######################
#User agent settings
######################  
        self.agent=self.web.get_settings()
        self.agent.set_property('user-agent', 'Mozilla/5.0 (X11; Linux) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.71 Safari/537.36')
        self.agent.set_property("enable-plugins", True)
        self.agent.set_property("enable-dom-paste", True)
        self.agent.set_property("enable-private-browsing", True)
        self.agent.set_property("enable-spatial-navigation", True)
        self.agent.set_property('enable-default-context-menu', True)
        self.agent.set_property('enable-fullscreen', True)
        self.agent.set_property('enable-media-stream', True)
        self.agent.set_property('enable-webaudio', True)
        self.web.set_settings(self.agent)  

#Cookies support
        home=os.getenv("HOME")
        print home
        os.chdir(home)
        cookies = Soup.CookieJarText.new("cookies_RunIT.txt", False)
        cookies.set_accept_policy(Soup.CookieJarAcceptPolicy.ALWAYS)
        cookie_session = WebKit.get_default_session()
        cookie_session.add_feature(cookies)
        
############
####Toolbar
########
        self.toolbar=Gtk.Toolbar()
        self.toolbar.set_size_request(20, 20)        

##################
#Go Back and Forward
####################

        self.back_button=Gtk.ToolButton(Gtk.STOCK_GO_BACK)
        self.back_button.connect("clicked", self.back)
        self.back_button.set_tooltip_text ("Go back")
        self.toolbar.insert(self.back_button, -1)      
        
        self.forward_button=Gtk.ToolButton(Gtk.STOCK_GO_FORWARD)
        self.forward_button.connect("clicked", self.forward)
        self.forward_button.set_tooltip_text ("Go forward")
        self.toolbar.insert(self.forward_button, -1)
#################################

#Reload and Home
        self.reload_button=Gtk.ToolButton(Gtk.STOCK_REFRESH)
        self.reload_button.connect("clicked", self.reloads)
        self.reload_button.set_tooltip_text ("Reload")
        self.toolbar.insert(self.reload_button, -1)
        
        self.home_button=Gtk.ToolButton(Gtk.STOCK_HOME)
        self.home_button.connect("clicked", self.home)
        self.home_button.set_tooltip_text ("Go Home")
        self.toolbar.insert(self.home_button, -1)
####################        
#Stop and Print        
#####################        
        self.stop_button=Gtk.ToolButton(Gtk.STOCK_STOP)
        self.stop_button.connect("clicked", self.stop)
        self.stop_button.set_tooltip_text ("Stop")
        self.toolbar.insert(self.stop_button, -1)
        
        self.print_button=Gtk.ToolButton(Gtk.STOCK_PRINT)
        self.print_button.connect("clicked", self.printing)
        self.print_button.set_tooltip_text ("Print")
        self.toolbar.insert(self.print_button, -1)
#####################################################
#Download and Bookmarks
#########################           
        self.download_button=Gtk.ToolButton(Gtk.STOCK_GOTO_BOTTOM)
        self.download_button.connect("clicked", self.download)
        self.download_button.set_label("Download file from addressbar location ")
        self.download_button.set_tooltip_text ("Download file from addressbar location")
        self.toolbar.insert(self.download_button, -1)
        
        self.downlist_button=Gtk.ToolButton(Gtk.STOCK_COPY)
        self.downlist_button.connect("clicked", self.downopen)
        self.downlist_button.set_tooltip_text ("View Download history")
        self.downlist_button.set_label("View Download history")
        self.toolbar.insert(self.downlist_button, -1)
        
        self.bookmarks_button=Gtk.ToolButton(Gtk.STOCK_ABOUT)
        self.bookmarks_button.connect("clicked", self.bookmarks)
        self.bookmarks_button.set_label("Bookmark addressbar location ")
        self.bookmarks_button.set_tooltip_text ("Bookmark addressbar location")
        self.toolbar.insert(self.bookmarks_button, -1)
        
        self.bookopen_button=Gtk.ToolButton(Gtk.STOCK_INDEX)
        self.bookopen_button.connect("clicked", self.bookopen)
        self.bookopen_button.set_label("Go to bookmarks")
        self.bookopen_button.set_tooltip_text ("Go to bookmarks")
        self.toolbar.insert(self.bookopen_button, -1)
 
#Clear cookies file button
        
        self.cookies_button=Gtk.ToolButton(Gtk.STOCK_CLEAR)
        self.cookies_button.connect("clicked", self.cookies_clear)
        self.cookies_button.set_label("Clear cookies file")
        self.cookies_button.set_tooltip_text ("Clear cookies file")
        self.toolbar.insert(self.cookies_button, -1)        
########################################################################        
#Zoom in and out
#####################
                
        self.zoomin_button=Gtk.ToolButton(Gtk.STOCK_ZOOM_IN)
        self.zoomin_button.connect("clicked", self.zoomin)
        self.zoomin_button.set_tooltip_text ("Zoom +")
        self.zoomin_button.set_label("Zoom in")
        self.toolbar.insert(self.zoomin_button, -1)
        
        self.zoomout_button=Gtk.ToolButton(Gtk.STOCK_ZOOM_OUT)
        self.zoomout_button.connect("clicked", self.zoomout)
        self.zoomout_button.set_tooltip_text ("Zoom -")
        self.zoomout_button.set_label("Zoom out")
        self.toolbar.insert(self.zoomout_button, -1)
#######################
####MENUS
#################
#Create menubar
        self.bar=Gtk.MenuBar()

###FILE MENU
    #Create menu items for File menu

        self.file_menu=Gtk.Menu()
        self.filemenu=Gtk.MenuItem("File")
        self.filemenu.set_submenu(self.file_menu)
 
#Close button for file menu

        self.away=Gtk.MenuItem("Close")
        self.away.connect("activate", Gtk.main_quit)

#About button for file menu

        self.about=Gtk.MenuItem("About")
        self.about.connect("activate", self.about1)       

#Appending things to file menu
        self.file_menu.append(self.about)
        self.file_menu.append(self.away)

#Appending items to menubar
        self.bar.append(self.filemenu)
########################################
###############
#Addressbars
################
        self.address=Gtk.Entry()
        self.address.connect("activate", self.actual_going)

#Search bar
        self.searching=Gtk.Entry()
        self.searching.set_text("Search")
        self.searching.select_region(0, len(self.searching.get_text()))
        self.searching.connect("activate", self.actual_finding)
        self.searching.set_text("Search")

############################
        scrolled_window = Gtk.ScrolledWindow()
        scrolled_window.add(self.web)

#Find Buttons
        find_box = Gtk.HBox()
        close_button = Gtk.Button("Close")
        close_button.connect("clicked", lambda x: find_box.hide())
        self.find_entry = Gtk.Entry()
        self.find_entry.connect("activate",
                                lambda x: self.web.search_text(self.find_entry.get_text(),
                                                                   False, True, True))
        prev_button = Gtk.Button("Previous")
        next_button = Gtk.Button("Next")
        prev_button.connect("clicked",
                            lambda x: self.web.search_text(self.find_entry.get_text(),
                                                               False, False, True))
        next_button.connect("clicked",
                            lambda x: self.web.search_text(self.find_entry.get_text(),
                                                               False, True, True))
        find_box.pack_start(close_button, False, False, 0)
        find_box.pack_start(self.find_entry, False, False, 0)
        find_box.pack_start(prev_button, False, False, 0)
        find_box.pack_start(next_button, False, False, 0)
        self.find_box = find_box
#####################################
#Main Box
#########################################
#CSS Styles
        style_provider = Gtk.CssProvider()
        css = open('/usr/share/RunIT/run.css', 'rb')
        css_data = css.read()
        css.close()
        style_provider.load_from_data(css_data)
        Gtk.StyleContext.add_provider_for_screen(
            Gdk.Screen.get_default(),
            style_provider,
            Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION) 

        url_box = Gtk.HBox()
        url_box.pack_start(self.bar, False, False, 2)   
        url_box.pack_start(self.address, True, True, 0)
        url_box.pack_start(self.searching, False, False, 2)   
        url_box2 = Gtk.VBox()
        url_box2.pack_start(self.toolbar, True, True, 0)

        self.pack_start(url_box, False, False, 0)
        self.pack_start(url_box2, False, False, 0)
        self.pack_start(scrolled_window, True, True, 0)
        self.pack_start(find_box, False, False, 0)

        url_box.show_all()
        url_box2.show_all()
        scrolled_window.show_all()
################
#Functions
################

#Clear cookies file
    def cookies_clear(self,widget):
        home=os.getenv("HOME")
        print home
        os.chdir(home)
        f = open('cookies_RunIT.txt', 'w')
        f.close()

#Navigation	
    def navigation(self,web,frame,title):
		page=frame.get_uri()
		self.address.set_text(page)

#Search from DuckDuckGO function
    
    def actual_finding(self,widget):
            bar=self.searching.get_text()
            adds1="https://duckduckgo.com/?q=" + bar
            self.web.load_uri(adds1)
            print adds1
            self.address.set_text(adds1)
            adda=self.address.get_text()
            self.web.load_uri(adda)
            self.searching.set_text("Search")
       		  		                    	        
#About dialog function
    def about1 (self, widget):
        about1 = Gtk.AboutDialog()
        about1.set_program_name("RunIT")
        about1.set_version("0.2-CSS")
        about1.set_copyright(" Copyright (c) 2015 JJ Posti <techtimejourney.net>")
        about1.set_comments("RunIT comes with ABSOLUTELY NO WARRANTY; for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991.--------------------------------------------------------------------------- Supported shortkeys:    Control+q:Close tab ---- Control+t:Open tab  ---- Control+f: Open Find dialog}")
        about1.set_website("www.techtimejourney.net")
        about1.run()
        about1.destroy()

#Go to page Function
    def actual_going(self, widget):
        add=self.address.get_text()
        if add.startswith("file:///"):
            self.web.load_uri(add)
            self.address.set_text(add)
                
        elif add.startswith("https://"):
            self.web.load_uri(add)
            self.address.set_text(add)    
        elif add.startswith("http://"):
            self.web.load_uri(add)
            self.address.set_text(add)    
        else:
            add="http://" + add
            self.web.load_uri(add)
            self.address.set_text(add)
#Back function
    def back(self,widget):
        goback=self.web.go_back()
	
#Forward function	
    def forward(self,widget):	
        self.web.go_forward()       

#Reload function

    def reloads(self,widget):	
        self.web.reload()

#Home page function
    def home(self,widget):
        self.web.open("http://techtimejourney.net/audax")
        
#Print
    def printing (self,widget):
        main = self.web.get_main_frame()
        main.print_full(Gtk.PrintOperation(), Gtk.PrintOperationAction.PRINT_DIALOG);        

#Stop
    def stop(self,widget):	
        self.web.stop_loading()

#Simple text Bookmark function
    def bookmarks(self,widget):
        home=os.getenv("HOME")
        print home
        site=str(self.address.get_text())
        os.chdir(home) 
        f = open('bookmarks.txt', 'a')
        f.write(site)
        f.write('\n')
        f.write('\n')
        f.close()
        print site

#Open bookmarks file
    def bookopen(self,widget):
    	home=os.getenv("HOME")
        print home
        home=os.getenv("HOME")
        os.chdir(home)
        head="file:///"
        books="bookmarks.txt"
        adds=self.address.set_text(head + home + '/' + books)
        adda=self.address.get_text()
        self.web.load_uri(adda) 				
		
#Download file
    def download(self,widget):
        add=self.address.get_text()
        home=os.getenv("HOME")
        print home
        os.chdir(home)
        downloaded = 'Downloaded_files' 
        if not os.path.exists(downloaded):
			os.makedirs(downloaded)
        os.chdir(downloaded)
        downloads=subprocess.Popen(['wget', add])
        downloads
        now = str(datetime.datetime.now())
        site=str(self.address.get_text())
        f = open('download_history.txt', 'a')
        f.write(now)
        f.write(':')
        f.write('\n')
        f.write(site)
        f.write('\n')
        f.write('\n')
        f.close()
        print site

    def downopen(self,widget):
    	home=os.getenv("HOME")
        print home
        home=os.getenv("HOME")
        os.chdir(home)
        downloaded='Downloaded_files' 
        os.chdir(downloaded)
        head="file:///"
        loads="download_history.txt"
        adds=self.address.set_text(head + home + '/' + downloaded + '/' + loads)
        adda=self.address.get_text()
        self.web.load_uri(adda)         

#Zooms   
    def zoomin(self,widget):
	    self.web.zoom_in()

    def zoomout(self,widget):
	    self.web.zoom_out()
	    	    
class Browser(Gtk.Window):
    
    def __init__(self, *args, **kwargs):
        super(Browser, self).__init__(*args, **kwargs)         
        self.set_default_size(1240, 790)
        self.set_title("RUNIT Browser")
        self.set_position(Gtk.WindowPosition.CENTER)


	# create notebook and tabs
	self.notebook = Gtk.Notebook()
	self.notebook.set_scrollable(True)

        self.tabs = []
	self.set_size_request(30,30)

        # create a first  tab
        self.tabs.append((self._create_tab(), Gtk.Label("New Tab")))
        self.notebook.append_page(*self.tabs[0])
        self.add(self.notebook)

	# connect signals
        self.connect("destroy", Gtk.main_quit)
        self.connect("key-press-event", self._key_pressed)
        self.notebook.connect("switch-page", self._tab_changed)

        titletab = BrowserTab()

        self.notebook.show()
        self.show()

    def _tab_changed(self, notebook, current_page, index):
        if not index:
            return    
        title = self.tabs[index][0].web.get_title()
        if title:
            self.set_title(title)

    def _title_changed(self, web, frame, title):
        current_page = self.notebook.get_current_page()

        counter = 0
        for tab, label in self.tabs:
            if tab.web is web:
                label.set_text(title)
                if counter == current_page:
                    self._tab_changed(None, None, counter)
                break
            counter += 1

    def _create_tab(self):
        tab = BrowserTab()
        tab.web.connect("title-changed", self._title_changed)
        return tab

    def _close_current_tab(self):
        if self.notebook.get_n_pages() == 1:
            return
        page = self.notebook.get_current_page()
        current_tab = self.tabs.pop(page)
        self.notebook.remove(current_tab[0])


    def _open_new_tab(self):
        current_page = self.notebook.get_current_page()
        page_tuple = (self._create_tab(), Gtk.Label("New Tab"))
        self.tabs.insert(current_page+1, page_tuple)
        self.notebook.insert_page(page_tuple[0], page_tuple[1], current_page+1)
        self.notebook.set_current_page(current_page+1)       

    def _raise_find_dialog(self):
        current_page = self.notebook.get_current_page()
        self.tabs[current_page][0].find_box.show_all()
        self.tabs[current_page][0].find_entry.grab_focus()
    
    def _key_pressed(self, widget, event):
        modifiers = Gtk.accelerator_get_default_mod_mask()
        mapping = {Gdk.KEY_q: self._close_current_tab,
                   Gdk.KEY_t: self._open_new_tab,
                   Gdk.KEY_f: self._raise_find_dialog}

        if event.state & modifiers == Gdk.ModifierType.CONTROL_MASK \
          and event.keyval in mapping:
            mapping[event.keyval]()
         
if __name__ == "__main__":
    Gtk.init(sys.argv)

    browser = Browser()

    Gtk.main()
